/* ccgo: gotime.hh
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#ifndef GOTIME_HH
#define GOTIME_HH
#include <gtk--.h>

class GoWin;

struct GameTime {
	int wt;
	int wb;
	int bt;
	int bb;
};

class GoTime :
	public Gtk::VBox
{
public:
	GoTime(GoWin &);
	~GoTime();
	void set_time(int, int, int, int);
	void set_time(const GameTime &);
	void start();
	void stop();
	void cont();
	SigC::Signal0<void> timeup;
	void switching();
	void set_byotime(int);
protected:
	virtual void realize_impl();
	virtual void style_changed_impl(Gtk::Style *);
private:
	GoWin & g;
	Gtk::Label w_timing;
	Gtk::Label b_timing;
	int wtime;
	int wbyo;
	int btime;
	int bbyo;
	int main_time;
	int byo_time;
	int byo_stones;
	SigC::Connection tc;
	gint time_down();
	void update_timing();
	bool running;
	void adj_sizes();
};
#endif /* GOTIME_HH */
