/* ccgo: igsconsole.hh
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#include <gtk--.h>
#include <vector>
#include <string>

class IgsCommand :
	public Gtk::Entry
{
public:
	IgsCommand();
	void clear_history();
protected:
	virtual gint key_press_event_impl(GdkEventKey *);
	virtual void activate_impl();
private:
	std::vector<std::string> hist;
	std::vector<std::string>::reverse_iterator ri;
	std::string current_line;
};

class IgsConsole :
	public Gtk::VBox
{
public:
	enum TextType {
		TT_NORMAL,
		TT_FIXED,
		TT_SYSTEM,
		TT_YELL,
		TT_FILE
	};
	IgsConsole();
	~IgsConsole();
	SigC::Signal1<void, const std::string &> enter;
	void dump(const std::string &, TextType = TT_NORMAL);
	void set_prompt(const std::string &);
	void clear_history();
	void set_visible(bool);
	void set_input_active(bool);
private:
	Gtk::Text text_dump;
	IgsCommand command_line;
	Gtk::Label prompt;
	void enter_line();
// 	void style_fix(Gtk::Style *);
	Gtk::Text_Helpers::Context ct_fixed;
	Gtk::Text_Helpers::Context ct_system;
	Gtk::Text_Helpers::Context ct_yell;
	Gtk::Text_Helpers::Context ct_file;
	int key_handles(GdkEventKey *);
};
